com.jnape.palatable.lambda.functions.builtin.fn2

## Class Both<A,B,C>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn2.Both<A,B,C>

- Type Parameters:
    `A` - both function's input type
    `B` - the first function return type
    `C` - the second function return type
  All Implemented Interfaces:
    Fn1<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>>, Fn2<Fn1<? super A,? extends B>,Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>, Fn3<Fn1<? super A,? extends B>,Fn1<? super A,? extends C>,A,Tuple2<B,C>>, Applicative<Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<Fn1<? super A,? extends B>,?>>, Cartesian<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<?,?>>, Cocartesian<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<?,?>>, Contravariant<Fn1<? super A,? extends B>,Profunctor<?,Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<?,?>>>, Functor<Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<Fn1<? super A,? extends B>,?>>, Profunctor<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<?,?>>, Monad<Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadReader<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadRec<Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadWriter<Fn1<? super A,? extends B>,Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>,Fn1<Fn1<? super A,? extends B>,?>>

      public final class Both<A,B,C>
      extends Object
      implements Fn3<Fn1<? super A,? extends B>,Fn1<? super A,? extends C>,A,Tuple2<B,C>>

  Given two functions `f` and `g`, produce a ``Fn1`<A, `Tuple2`<B, C>>` (the dual application of both functions).

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <A,B,C> Both<A,B,C>` | `both()`
    `static <A,B,C> Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>>` | `both(Fn1<? super A,? extends B> f)`
    `static <A,B,C> Fn1<A,Tuple2<B,C>>` | `both(Fn1<? super A,? extends B> f, Fn1<? super A,? extends C> g)`
    `static <A,B,C> Tuple2<B,C>` | `both(Fn1<? super A,? extends B> f, Fn1<? super A,? extends C> g, A a)`
    `Tuple2<B,C>` | `checkedApply(Fn1<? super A,? extends B> f, Fn1<? super A,? extends C> g, A a)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Tuple2<B,C> checkedApply(Fn1<? super A,? extends B> f,
                                          Fn1<? super A,? extends C> g,
                                          A a)

      Specified by:
        `checkedApply` in interface `Fn3<Fn1<? super A,? extends B>,Fn1<? super A,? extends C>,A,Tuple2<B,C>>`

    - #### both

          public static <A,B,C> Both<A,B,C> both()

    - #### both

          public static <A,B,C> Fn1<Fn1<? super A,? extends C>,Fn1<A,Tuple2<B,C>>> both(Fn1<? super A,? extends B> f)

    - #### both

          public static <A,B,C> Fn1<A,Tuple2<B,C>> both(Fn1<? super A,? extends B> f,
                                                        Fn1<? super A,? extends C> g)

    - #### both

          public static <A,B,C> Tuple2<B,C> both(Fn1<? super A,? extends B> f,
                                                 Fn1<? super A,? extends C> g,
                                                 A a)